// Code generated by ent, DO NOT EDIT.

package subjectdigest

import (
	"entgo.io/ent/dialect/sql"
	"entgo.io/ent/dialect/sql/sqlgraph"
	"github.com/google/uuid"
	"github.com/in-toto/archivista/ent/predicate"
)

// ID filters vertices based on their ID field.
func ID(id uuid.UUID) predicate.SubjectDigest {
	return predicate.SubjectDigest(sql.FieldEQ(FieldID, id))
}

// IDEQ applies the EQ predicate on the ID field.
func IDEQ(id uuid.UUID) predicate.SubjectDigest {
	return predicate.SubjectDigest(sql.FieldEQ(FieldID, id))
}

// IDNEQ applies the NEQ predicate on the ID field.
func IDNEQ(id uuid.UUID) predicate.SubjectDigest {
	return predicate.SubjectDigest(sql.FieldNEQ(FieldID, id))
}

// IDIn applies the In predicate on the ID field.
func IDIn(ids ...uuid.UUID) predicate.SubjectDigest {
	return predicate.SubjectDigest(sql.FieldIn(FieldID, ids...))
}

// IDNotIn applies the NotIn predicate on the ID field.
func IDNotIn(ids ...uuid.UUID) predicate.SubjectDigest {
	return predicate.SubjectDigest(sql.FieldNotIn(FieldID, ids...))
}

// IDGT applies the GT predicate on the ID field.
func IDGT(id uuid.UUID) predicate.SubjectDigest {
	return predicate.SubjectDigest(sql.FieldGT(FieldID, id))
}

// IDGTE applies the GTE predicate on the ID field.
func IDGTE(id uuid.UUID) predicate.SubjectDigest {
	return predicate.SubjectDigest(sql.FieldGTE(FieldID, id))
}

// IDLT applies the LT predicate on the ID field.
func IDLT(id uuid.UUID) predicate.SubjectDigest {
	return predicate.SubjectDigest(sql.FieldLT(FieldID, id))
}

// IDLTE applies the LTE predicate on the ID field.
func IDLTE(id uuid.UUID) predicate.SubjectDigest {
	return predicate.SubjectDigest(sql.FieldLTE(FieldID, id))
}

// Algorithm applies equality check predicate on the "algorithm" field. It's identical to AlgorithmEQ.
func Algorithm(v string) predicate.SubjectDigest {
	return predicate.SubjectDigest(sql.FieldEQ(FieldAlgorithm, v))
}

// Value applies equality check predicate on the "value" field. It's identical to ValueEQ.
func Value(v string) predicate.SubjectDigest {
	return predicate.SubjectDigest(sql.FieldEQ(FieldValue, v))
}

// AlgorithmEQ applies the EQ predicate on the "algorithm" field.
func AlgorithmEQ(v string) predicate.SubjectDigest {
	return predicate.SubjectDigest(sql.FieldEQ(FieldAlgorithm, v))
}

// AlgorithmNEQ applies the NEQ predicate on the "algorithm" field.
func AlgorithmNEQ(v string) predicate.SubjectDigest {
	return predicate.SubjectDigest(sql.FieldNEQ(FieldAlgorithm, v))
}

// AlgorithmIn applies the In predicate on the "algorithm" field.
func AlgorithmIn(vs ...string) predicate.SubjectDigest {
	return predicate.SubjectDigest(sql.FieldIn(FieldAlgorithm, vs...))
}

// AlgorithmNotIn applies the NotIn predicate on the "algorithm" field.
func AlgorithmNotIn(vs ...string) predicate.SubjectDigest {
	return predicate.SubjectDigest(sql.FieldNotIn(FieldAlgorithm, vs...))
}

// AlgorithmGT applies the GT predicate on the "algorithm" field.
func AlgorithmGT(v string) predicate.SubjectDigest {
	return predicate.SubjectDigest(sql.FieldGT(FieldAlgorithm, v))
}

// AlgorithmGTE applies the GTE predicate on the "algorithm" field.
func AlgorithmGTE(v string) predicate.SubjectDigest {
	return predicate.SubjectDigest(sql.FieldGTE(FieldAlgorithm, v))
}

// AlgorithmLT applies the LT predicate on the "algorithm" field.
func AlgorithmLT(v string) predicate.SubjectDigest {
	return predicate.SubjectDigest(sql.FieldLT(FieldAlgorithm, v))
}

// AlgorithmLTE applies the LTE predicate on the "algorithm" field.
func AlgorithmLTE(v string) predicate.SubjectDigest {
	return predicate.SubjectDigest(sql.FieldLTE(FieldAlgorithm, v))
}

// AlgorithmContains applies the Contains predicate on the "algorithm" field.
func AlgorithmContains(v string) predicate.SubjectDigest {
	return predicate.SubjectDigest(sql.FieldContains(FieldAlgorithm, v))
}

// AlgorithmHasPrefix applies the HasPrefix predicate on the "algorithm" field.
func AlgorithmHasPrefix(v string) predicate.SubjectDigest {
	return predicate.SubjectDigest(sql.FieldHasPrefix(FieldAlgorithm, v))
}

// AlgorithmHasSuffix applies the HasSuffix predicate on the "algorithm" field.
func AlgorithmHasSuffix(v string) predicate.SubjectDigest {
	return predicate.SubjectDigest(sql.FieldHasSuffix(FieldAlgorithm, v))
}

// AlgorithmEqualFold applies the EqualFold predicate on the "algorithm" field.
func AlgorithmEqualFold(v string) predicate.SubjectDigest {
	return predicate.SubjectDigest(sql.FieldEqualFold(FieldAlgorithm, v))
}

// AlgorithmContainsFold applies the ContainsFold predicate on the "algorithm" field.
func AlgorithmContainsFold(v string) predicate.SubjectDigest {
	return predicate.SubjectDigest(sql.FieldContainsFold(FieldAlgorithm, v))
}

// ValueEQ applies the EQ predicate on the "value" field.
func ValueEQ(v string) predicate.SubjectDigest {
	return predicate.SubjectDigest(sql.FieldEQ(FieldValue, v))
}

// ValueNEQ applies the NEQ predicate on the "value" field.
func ValueNEQ(v string) predicate.SubjectDigest {
	return predicate.SubjectDigest(sql.FieldNEQ(FieldValue, v))
}

// ValueIn applies the In predicate on the "value" field.
func ValueIn(vs ...string) predicate.SubjectDigest {
	return predicate.SubjectDigest(sql.FieldIn(FieldValue, vs...))
}

// ValueNotIn applies the NotIn predicate on the "value" field.
func ValueNotIn(vs ...string) predicate.SubjectDigest {
	return predicate.SubjectDigest(sql.FieldNotIn(FieldValue, vs...))
}

// ValueGT applies the GT predicate on the "value" field.
func ValueGT(v string) predicate.SubjectDigest {
	return predicate.SubjectDigest(sql.FieldGT(FieldValue, v))
}

// ValueGTE applies the GTE predicate on the "value" field.
func ValueGTE(v string) predicate.SubjectDigest {
	return predicate.SubjectDigest(sql.FieldGTE(FieldValue, v))
}

// ValueLT applies the LT predicate on the "value" field.
func ValueLT(v string) predicate.SubjectDigest {
	return predicate.SubjectDigest(sql.FieldLT(FieldValue, v))
}

// ValueLTE applies the LTE predicate on the "value" field.
func ValueLTE(v string) predicate.SubjectDigest {
	return predicate.SubjectDigest(sql.FieldLTE(FieldValue, v))
}

// ValueContains applies the Contains predicate on the "value" field.
func ValueContains(v string) predicate.SubjectDigest {
	return predicate.SubjectDigest(sql.FieldContains(FieldValue, v))
}

// ValueHasPrefix applies the HasPrefix predicate on the "value" field.
func ValueHasPrefix(v string) predicate.SubjectDigest {
	return predicate.SubjectDigest(sql.FieldHasPrefix(FieldValue, v))
}

// ValueHasSuffix applies the HasSuffix predicate on the "value" field.
func ValueHasSuffix(v string) predicate.SubjectDigest {
	return predicate.SubjectDigest(sql.FieldHasSuffix(FieldValue, v))
}

// ValueEqualFold applies the EqualFold predicate on the "value" field.
func ValueEqualFold(v string) predicate.SubjectDigest {
	return predicate.SubjectDigest(sql.FieldEqualFold(FieldValue, v))
}

// ValueContainsFold applies the ContainsFold predicate on the "value" field.
func ValueContainsFold(v string) predicate.SubjectDigest {
	return predicate.SubjectDigest(sql.FieldContainsFold(FieldValue, v))
}

// HasSubject applies the HasEdge predicate on the "subject" edge.
func HasSubject() predicate.SubjectDigest {
	return predicate.SubjectDigest(func(s *sql.Selector) {
		step := sqlgraph.NewStep(
			sqlgraph.From(Table, FieldID),
			sqlgraph.Edge(sqlgraph.M2O, true, SubjectTable, SubjectColumn),
		)
		sqlgraph.HasNeighbors(s, step)
	})
}

// HasSubjectWith applies the HasEdge predicate on the "subject" edge with a given conditions (other predicates).
func HasSubjectWith(preds ...predicate.Subject) predicate.SubjectDigest {
	return predicate.SubjectDigest(func(s *sql.Selector) {
		step := newSubjectStep()
		sqlgraph.HasNeighborsWith(s, step, func(s *sql.Selector) {
			for _, p := range preds {
				p(s)
			}
		})
	})
}

// And groups predicates with the AND operator between them.
func And(predicates ...predicate.SubjectDigest) predicate.SubjectDigest {
	return predicate.SubjectDigest(sql.AndPredicates(predicates...))
}

// Or groups predicates with the OR operator between them.
func Or(predicates ...predicate.SubjectDigest) predicate.SubjectDigest {
	return predicate.SubjectDigest(sql.OrPredicates(predicates...))
}

// Not applies the not operator on the given predicate.
func Not(p predicate.SubjectDigest) predicate.SubjectDigest {
	return predicate.SubjectDigest(sql.NotPredicates(p))
}
